diff --git a/configure.ac b/configure.ac
index 76ca9c1..7a5a9ac 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1795,6 +1795,7 @@ AC_OUTPUT([
 	src/zabbix_server/odbc/Makefile
 	src/zabbix_server/scripts/Makefile
 	src/zabbix_server/preprocessor/Makefile
+	src/zabbix_server/availability/Makefile
 	src/zabbix_proxy/Makefile
 	src/zabbix_proxy/heart/Makefile
 	src/zabbix_proxy/housekeeper/Makefile
diff --git a/include/common.h b/include/common.h
index 1562cdf..4d134fe 100644
--- a/include/common.h
+++ b/include/common.h
@@ -500,36 +500,37 @@ zbx_group_status_type_t;
 const char	*get_program_type_string(unsigned char program_type);
 
 /* process type */
-#define ZBX_PROCESS_TYPE_POLLER		0
-#define ZBX_PROCESS_TYPE_UNREACHABLE	1
-#define ZBX_PROCESS_TYPE_IPMIPOLLER	2
-#define ZBX_PROCESS_TYPE_PINGER		3
-#define ZBX_PROCESS_TYPE_JAVAPOLLER	4
-#define ZBX_PROCESS_TYPE_HTTPPOLLER	5
-#define ZBX_PROCESS_TYPE_TRAPPER	6
-#define ZBX_PROCESS_TYPE_SNMPTRAPPER	7
-#define ZBX_PROCESS_TYPE_PROXYPOLLER	8
-#define ZBX_PROCESS_TYPE_ESCALATOR	9
-#define ZBX_PROCESS_TYPE_HISTSYNCER	10
-#define ZBX_PROCESS_TYPE_DISCOVERER	11
-#define ZBX_PROCESS_TYPE_ALERTER	12
-#define ZBX_PROCESS_TYPE_TIMER		13
-#define ZBX_PROCESS_TYPE_HOUSEKEEPER	14
-#define ZBX_PROCESS_TYPE_DATASENDER	15
-#define ZBX_PROCESS_TYPE_CONFSYNCER	16
-#define ZBX_PROCESS_TYPE_HEARTBEAT	17
-#define ZBX_PROCESS_TYPE_SELFMON	18
-#define ZBX_PROCESS_TYPE_VMWARE		19
-#define ZBX_PROCESS_TYPE_COLLECTOR	20
-#define ZBX_PROCESS_TYPE_LISTENER	21
-#define ZBX_PROCESS_TYPE_ACTIVE_CHECKS	22
-#define ZBX_PROCESS_TYPE_TASKMANAGER	23
-#define ZBX_PROCESS_TYPE_IPMIMANAGER	24
-#define ZBX_PROCESS_TYPE_ALERTMANAGER	25
-#define ZBX_PROCESS_TYPE_PREPROCMAN	26
-#define ZBX_PROCESS_TYPE_PREPROCESSOR	27
-#define ZBX_PROCESS_TYPE_COUNT		28	/* number of process types */
-#define ZBX_PROCESS_TYPE_UNKNOWN	255
+#define ZBX_PROCESS_TYPE_POLLER			0
+#define ZBX_PROCESS_TYPE_UNREACHABLE		1
+#define ZBX_PROCESS_TYPE_IPMIPOLLER		2
+#define ZBX_PROCESS_TYPE_PINGER			3
+#define ZBX_PROCESS_TYPE_JAVAPOLLER		4
+#define ZBX_PROCESS_TYPE_HTTPPOLLER		5
+#define ZBX_PROCESS_TYPE_TRAPPER		6
+#define ZBX_PROCESS_TYPE_SNMPTRAPPER		7
+#define ZBX_PROCESS_TYPE_PROXYPOLLER		8
+#define ZBX_PROCESS_TYPE_ESCALATOR		9
+#define ZBX_PROCESS_TYPE_HISTSYNCER		10
+#define ZBX_PROCESS_TYPE_DISCOVERER		11
+#define ZBX_PROCESS_TYPE_ALERTER		12
+#define ZBX_PROCESS_TYPE_TIMER			13
+#define ZBX_PROCESS_TYPE_HOUSEKEEPER		14
+#define ZBX_PROCESS_TYPE_DATASENDER		15
+#define ZBX_PROCESS_TYPE_CONFSYNCER		16
+#define ZBX_PROCESS_TYPE_HEARTBEAT		17
+#define ZBX_PROCESS_TYPE_SELFMON		18
+#define ZBX_PROCESS_TYPE_VMWARE			19
+#define ZBX_PROCESS_TYPE_COLLECTOR		20
+#define ZBX_PROCESS_TYPE_LISTENER		21
+#define ZBX_PROCESS_TYPE_ACTIVE_CHECKS		22
+#define ZBX_PROCESS_TYPE_TASKMANAGER		23
+#define ZBX_PROCESS_TYPE_IPMIMANAGER		24
+#define ZBX_PROCESS_TYPE_ALERTMANAGER		25
+#define ZBX_PROCESS_TYPE_PREPROCMAN		26
+#define ZBX_PROCESS_TYPE_PREPROCESSOR		27
+#define ZBX_PROCESS_TYPE_AVAILABILITY_SYNCER	28
+#define ZBX_PROCESS_TYPE_COUNT			29	/* number of process types */
+#define ZBX_PROCESS_TYPE_UNKNOWN		255
 const char	*get_process_type_string(unsigned char process_type);
 int		get_process_type_by_name(const char *proc_type_str);
 
@@ -594,6 +595,8 @@ zbx_maintenance_type_t;
 #define HOST_AVAILABLE_UNKNOWN		0
 #define HOST_AVAILABLE_TRUE		1
 #define HOST_AVAILABLE_FALSE		2
+#define HOST_AVAILABLE_PARTIAL		3
+#define HOST_AVAILABLE_UNSET		4
 
 /* trigger statuses */
 #define TRIGGER_STATUS_ENABLED		0
diff --git a/include/db.h b/include/db.h
index 1bec8aa..cc42919 100644
--- a/include/db.h
+++ b/include/db.h
@@ -663,49 +663,6 @@ void	zbx_db_insert_clean(zbx_db_insert_t *self);
 void	zbx_db_insert_autoincrement(zbx_db_insert_t *self, const char *field_name);
 int	zbx_db_get_database_type(void);
 
-/* agent (ZABBIX, SNMP, IPMI, JMX) availability data */
-typedef struct
-{
-	/* flags specifying which fields are set, see ZBX_FLAGS_AGENT_STATUS_* defines */
-	unsigned char	flags;
-
-	/* agent availability fields */
-	unsigned char	available;
-	char		*error;
-	int		errors_from;
-	int		disable_until;
-}
-zbx_agent_availability_t;
-
-#define ZBX_FLAGS_AGENT_STATUS_NONE		0x00000000
-#define ZBX_FLAGS_AGENT_STATUS_AVAILABLE	0x00000001
-#define ZBX_FLAGS_AGENT_STATUS_ERROR		0x00000002
-#define ZBX_FLAGS_AGENT_STATUS_ERRORS_FROM	0x00000004
-#define ZBX_FLAGS_AGENT_STATUS_DISABLE_UNTIL	0x00000008
-
-#define ZBX_FLAGS_AGENT_STATUS		(ZBX_FLAGS_AGENT_STATUS_AVAILABLE |	\
-					ZBX_FLAGS_AGENT_STATUS_ERROR |		\
-					ZBX_FLAGS_AGENT_STATUS_ERRORS_FROM |	\
-					ZBX_FLAGS_AGENT_STATUS_DISABLE_UNTIL)
-
-#define ZBX_AGENT_ZABBIX	(INTERFACE_TYPE_AGENT - 1)
-#define ZBX_AGENT_SNMP		(INTERFACE_TYPE_SNMP - 1)
-#define ZBX_AGENT_IPMI		(INTERFACE_TYPE_IPMI - 1)
-#define ZBX_AGENT_JMX		(INTERFACE_TYPE_JMX - 1)
-#define ZBX_AGENT_UNKNOWN 	255
-#define ZBX_AGENT_MAX		INTERFACE_TYPE_COUNT
-
-typedef struct
-{
-	zbx_uint64_t			hostid;
-
-	zbx_agent_availability_t	agents[ZBX_AGENT_MAX];
-}
-zbx_host_availability_t;
-
-
-int	zbx_sql_add_host_availability(char **sql, size_t *sql_alloc, size_t *sql_offset,
-		const zbx_host_availability_t *ha);
 int	DBget_user_by_active_session(const char *sessionid, zbx_user_t *user);
 
 typedef struct
diff --git a/include/dbcache.h b/include/dbcache.h
index 3ecbe5b..63abce1 100644
--- a/include/dbcache.h
+++ b/include/dbcache.h
@@ -104,22 +104,10 @@ typedef struct
 	unsigned char	maintenance_status;
 	unsigned char	maintenance_type;
 	int		maintenance_from;
-	int		errors_from;
-	unsigned char	available;
-	int		disable_until;
-	int		snmp_errors_from;
-	unsigned char	snmp_available;
-	int		snmp_disable_until;
-	int		ipmi_errors_from;
-	unsigned char	ipmi_available;
-	int		ipmi_disable_until;
 	signed char	ipmi_authtype;
 	unsigned char	ipmi_privilege;
 	char		ipmi_username[HOST_IPMI_USERNAME_LEN_MAX];
 	char		ipmi_password[HOST_IPMI_PASSWORD_LEN_MAX];
-	int		jmx_errors_from;
-	unsigned char	jmx_available;
-	int		jmx_disable_until;
 	char		inventory_mode;
 	unsigned char	status;
 	unsigned char	tls_connect;
@@ -130,15 +118,30 @@ typedef struct
 	char		tls_psk_identity[HOST_TLS_PSK_IDENTITY_LEN_MAX];
 	char		tls_psk[HOST_TLS_PSK_LEN_MAX];
 #endif
-	char		error[HOST_ERROR_LEN_MAX];
-	char		snmp_error[HOST_ERROR_LEN_MAX];
-	char		ipmi_error[HOST_ERROR_LEN_MAX];
-	char		jmx_error[HOST_ERROR_LEN_MAX];
 }
 DC_HOST;
 
 typedef struct
 {
+	unsigned char	available;
+	char		*error;
+	int		errors_from;
+	int		disable_until;
+}
+zbx_agent_status_t;
+
+typedef struct
+{
+	zbx_uint64_t	hostid;
+	unsigned char	type;
+	unsigned int	flags;
+	unsigned char	available;
+	char		*error;
+}
+zbx_agent_status_update_t;
+
+typedef struct
+{
 	DC_HOST			host;
 	DC_INTERFACE		interface;
 	zbx_uint64_t		itemid;
@@ -197,6 +200,7 @@ typedef struct
 	char			ssl_key_file_orig[ITEM_SSL_KEY_FILE_LEN_MAX], *ssl_key_file;
 	char			ssl_key_password_orig[ITEM_SSL_KEY_PASSWORD_LEN_MAX], *ssl_key_password;
 	char			*error;
+	zbx_agent_status_t	agent;
 }
 DC_ITEM;
 
@@ -664,11 +668,8 @@ size_t	DCget_psk_by_identity(const unsigned char *psk_identity, unsigned char *p
 void	DCget_user_macro(const zbx_uint64_t *hostids, int host_num, const char *macro, char **replace_to);
 char	*DCexpression_expand_user_macros(const char *expression, char **error);
 
-int	DChost_activate(zbx_uint64_t hostid, unsigned char agent_type, const zbx_timespec_t *ts,
-		zbx_agent_availability_t *in, zbx_agent_availability_t *out);
-
-int	DChost_deactivate(zbx_uint64_t hostid, unsigned char agent, const zbx_timespec_t *ts,
-		zbx_agent_availability_t *in, zbx_agent_availability_t *out, const char *error);
+unsigned int	zbx_dc_item_activate(const DC_ITEM *item);
+unsigned int	zbx_dc_item_deactivate(const DC_ITEM *item, const zbx_timespec_t *ts, const char *error_msg);
 
 #define ZBX_QUEUE_FROM_DEFAULT	6	/* default lower limit for delay (in seconds) */
 #define ZBX_QUEUE_TO_INFINITY	-1	/* no upper limit for delay */
@@ -700,25 +701,14 @@ void	DCget_hosts_by_functionids(const zbx_vector_uint64_t *functionids, zbx_hash
 void	zbx_config_get(zbx_config_t *cfg, zbx_uint64_t flags);
 void	zbx_config_clean(zbx_config_t *cfg);
 
-int	DCset_hosts_availability(zbx_vector_ptr_t *availabilities);
-
-int	DCreset_hosts_availability(zbx_vector_ptr_t *hosts);
-void	DCupdate_hosts_availability(void);
+void	zbx_dc_reset_proxy_hosts_availability();
 
 void	zbx_dc_get_actions_eval(zbx_vector_ptr_t *actions, zbx_hashset_t *uniq_conditions, unsigned char opflags);
 void	zbx_action_eval_free(zbx_action_eval_t *action);
 void	zbx_db_condition_clean(DB_CONDITION *condition);
 void	zbx_conditions_eval_clean(zbx_hashset_t *uniq_conditions);
 
-int	DCget_hosts_availability(zbx_vector_ptr_t *hosts, int *ts);
-void	DCtouch_hosts_availability(const zbx_vector_uint64_t *hostids);
-
-void	zbx_host_availability_init(zbx_host_availability_t *availability, zbx_uint64_t hostid);
-void	zbx_host_availability_clean(zbx_host_availability_t *availability);
-void	zbx_host_availability_free(zbx_host_availability_t *availability);
-int	zbx_host_availability_is_set(const zbx_host_availability_t *ha);
-
-void	zbx_set_availability_diff_ts(int ts);
+void	zbx_dc_refresh_hosts_availability(const zbx_vector_uint64_t *hostids);
 
 void	zbx_dc_correlation_rules_init(zbx_correlation_rules_t *rules);
 void	zbx_dc_correlation_rules_clean(zbx_correlation_rules_t *rules);
@@ -782,4 +772,29 @@ void	zbx_dc_get_trigger_dependencies(const zbx_vector_uint64_t *triggerids, zbx_
 
 void	zbx_dc_reschedule_items(const zbx_vector_uint64_t *itemids, int now, zbx_uint64_t *proxy_hostids);
 
+int	zbx_dc_get_host_availability_updates(zbx_vector_ptr_t *availability);
+void	zbx_dc_get_host_availability(zbx_uint64_t hostid, zbx_agent_status_t *agents);
+void	zbx_dc_clean_host_availability(zbx_agent_status_t *agents);
+void	zbx_agent_status_update_free(void *data);
+void	zbx_refresh_host_availability(const zbx_vector_ptr_t *updates);
+void	zbx_dc_update_proxy_host_availability(const zbx_vector_ptr_t *updates);
+
+#define ZBX_AGENT_STATUS_NONE		0x00000000
+#define ZBX_AGENT_STATUS_AVAILABLE	0x00000001
+#define ZBX_AGENT_STATUS_ERROR		0x00000002
+#define ZBX_AGENT_STATUS_ERRORS_FROM	0x00000004
+#define ZBX_AGENT_STATUS_DISABLE_UNTIL	0x00000008
+
+#define ZBX_AGENT_STATUS		(ZBX_AGENT_STATUS_AVAILABLE |	\
+					ZBX_AGENT_STATUS_ERROR |	\
+					ZBX_AGENT_STATUS_ERRORS_FROM |	\
+					ZBX_AGENT_STATUS_DISABLE_UNTIL)
+
+#define ZBX_AGENT_ZABBIX	(INTERFACE_TYPE_AGENT - 1)
+#define ZBX_AGENT_SNMP		(INTERFACE_TYPE_SNMP - 1)
+#define ZBX_AGENT_IPMI		(INTERFACE_TYPE_IPMI - 1)
+#define ZBX_AGENT_JMX		(INTERFACE_TYPE_JMX - 1)
+#define ZBX_AGENT_UNKNOWN 	255
+#define ZBX_AGENT_MAX		INTERFACE_TYPE_COUNT
+
 #endif
diff --git a/include/proxy.h b/include/proxy.h
index 447aa28..17f9cc8 100644
--- a/include/proxy.h
+++ b/include/proxy.h
@@ -42,7 +42,7 @@ void	update_proxy_lastaccess(const zbx_uint64_t hostid, time_t last_access);
 int	get_proxyconfig_data(zbx_uint64_t proxy_hostid, struct zbx_json *j, char **error);
 void	process_proxyconfig(struct zbx_json_parse *jp_data);
 
-int	get_host_availability_data(struct zbx_json *j, int *ts);
+int	get_host_availability_data(struct zbx_json *j, zbx_vector_ptr_t *updates);
 int	process_host_availability(struct zbx_json_parse *jp_data, char **error);
 
 int	proxy_get_hist_data(struct zbx_json *j, zbx_uint64_t *lastid, int *more);
diff --git a/src/libs/zbxcommon/str.c b/src/libs/zbxcommon/str.c
index d9cf872..8049900 100644
--- a/src/libs/zbxcommon/str.c
+++ b/src/libs/zbxcommon/str.c
@@ -1973,6 +1973,8 @@ const char	*get_process_type_string(unsigned char proc_type)
 			return "preprocessing manager";
 		case ZBX_PROCESS_TYPE_PREPROCESSOR:
 			return "preprocessing worker";
+		case ZBX_PROCESS_TYPE_AVAILABILITY_SYNCER:
+			return "availability syncer";
 	}
 
 	THIS_SHOULD_NEVER_HAPPEN;
diff --git a/src/libs/zbxdbcache/dbcache.c b/src/libs/zbxdbcache/dbcache.c
index f28720c..cde8cf2 100644
--- a/src/libs/zbxdbcache/dbcache.c
+++ b/src/libs/zbxdbcache/dbcache.c
@@ -4269,6 +4269,7 @@ zbx_uint64_t	DCget_nextid(const char *table_name, int num)
  *          on interfaces without enabled items                               *
  *                                                                            *
  ******************************************************************************/
+#ifdef DUMMY
 void	DCupdate_hosts_availability(void)
 {
 	const char		*__function_name = "DCupdate_hosts_availability";
@@ -4312,3 +4313,4 @@ out:
 
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
 }
+#endif
